#include "evenement.h"
#include "ecran.h"
#include "jeu.h"
#include "souris.h"

int main(void)
{
  int fin=0;
  init_screen();
  init_jeu();
  affiche_jeu();
  while(!fin) {
    evenement x;
    next_evenement (&x);
    if (x.type==CLAVIER) {
      switch (x.cas.touche) {
	case FLECHE_GAUCHE : if (bouge_a_gauche()) affiche_jeu(); break;
        case FLECHE_DROITE : if (bouge_a_droite()) affiche_jeu(); break;
        case ESPACE        : if (fait_tourner())   affiche_jeu(); break;
	case ECHAP         : fin++; break;
      }
    }
    if (x.type==SOURIS) {
      if (dans_case_gauche(x.cas.pos.x, x.cas.pos.y))
	if (bouge_a_gauche()) affiche_jeu();
      if (dans_case_droite(x.cas.pos.x, x.cas.pos.y))
	if (bouge_a_droite()) affiche_jeu();
      if (dans_case_tourne(x.cas.pos.x, x.cas.pos.y))
	if (fait_tourner()) affiche_jeu();
      if (dans_case_quitte(x.cas.pos.x, x.cas.pos.y)) fin++;
    }
  }
  close_screen();
  close_jeu();

  return 0;
}
