#include "jeu.h"

#include "X_routines.h"

trou_pos jeu[7];
int pos_jeu;      /* dit ou est mise la reglette */
int gagne;

void init_jeu(void)
{
  int i;
  gagne=0;
  pos_jeu=6;
  for (i=0; i<7; i++) jeu[i]=TROU_HAUT;
}

void close_jeu(void)
{
  /* rien a faire. Pourquoi la fct ? Because design ! */
}

void gagne_jeu(void)
{
  gagne=1;
}

int regarde_gagne(void)
{
  if (pos_jeu==-2) {
    gagne++;
    return (1==1);
  }
  return (1==0);
}

int bouge_a_gauche(void)
{
  if (pos_jeu==6) return (1==0);
  if (jeu[pos_jeu]==TROU_BAS) return (1==0);
  pos_jeu++;
  return (1==1);
}

int bouge_a_droite(void)
{
  if (pos_jeu==-2) return (1==0);
  if (jeu[pos_jeu+1]==TROU_HAUT) return (1==0);
  if (pos_jeu!=-1 && jeu[pos_jeu]==TROU_BAS) return (1==0);
  pos_jeu--;
  return (1==1);
}

trou_pos tourne (trou_pos x)
{
  switch (x) {
    case TROU_HAUT   : return TROU_GAUCHE;
    case TROU_GAUCHE : return TROU_BAS;
    case TROU_BAS    : return TROU_DROIT;
    case TROU_DROIT  : return TROU_HAUT;
  }
  return TROU_HAUT; /* je veux pas de warning au compil-time */
}

int fait_tourner(void)
{
  if (pos_jeu<0) return (1==0);
  if (pos_jeu==5 && jeu[6]==TROU_DROIT) return (1==0);
  if (pos_jeu!=6 && jeu[pos_jeu+1]==TROU_GAUCHE) return (1==0);
  if (pos_jeu!=0 && jeu[pos_jeu-1]==TROU_DROIT) return (1==0);
  jeu[pos_jeu]=tourne(jeu[pos_jeu]);
  return (1==1);
}

#include "X_routines.h"

void _affiche(int x)
{
  if (x==6) {X_put_derniere_chose(x+7-pos_jeu, jeu[x]); return;}
  if (jeu[x]==TROU_DROIT) {
    _affiche(x+1);
    X_put_chose (x+7-pos_jeu, jeu[x]);
  }
  else {
    X_put_chose (x+7-pos_jeu, jeu[x]);
    _affiche(x+1);
  }
}

void affiche_jeu(void)
{
  X_clear_screen();
  X_put_fond();
  _affiche (0);
}
